<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use \Teknisa\Model\Traits\TQuery;

class ContractModelFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getContractModel()
    {
        $sql = "SELECT
            FCT_MODELOCONTRATO.NRDIASREAJAUTOMATICO,
            FCT_MODELOCONTRATO.IDGERAPROPOSTA,
            FCT_MODELOCONTRATO.NRSEQMODCONTRA,
            FCT_MODELOCONTRATO.CDMODCONTRATO,
            FCT_MODELOCONTRATO.NMMODCONTRATO,
            FCT_MODELOCONTRATO.NRDIASVIGCONT,
            FCT_MODELOCONTRATO.DTPADREAJCONT,
            FCT_MODELOCONTRATO.NRDIASPRORGCONT,
            FCT_MODELOCONTRATO.QTPOSTOTRABCONT,
            FCT_MODELOCONTRATO.VRPERCMULTQBCONT,
            FCT_MODELOCONTRATO.CDINDFINCONT,
            FCT_MODELOCONTRATO.CDTPINDFINCON,
            FCT_MODELOCONTRATO.IDPERVALFINCON,
            FCT_MODELOCONTRATO.IDTPREAJUSTE,
            FCT_MODELOCONTRATO.IDTPMESREAJUSTE,
            FCT_MODELOCONTRATO.NRQTDREAJUSTE,
            FCT_MODELOCONTRATO.IDSOMAFATUCONT,
            FCT_MODELOCONTRATO.IDBLOQSEMMEDIC,
            FCT_MODELOCONTRATO.IDBLOQVRMEDIC,
            FCT_MODELOCONTRATO.NRORG,
            FCT_MODELOCONTRATO.DTINCLUSAO,
            FCT_MODELOCONTRATO.NRORGINCLUSAO,
            FCT_MODELOCONTRATO.CDOPERINCLUSAO,
            OPINC.NMOPERADOR AS NMOPERINCLUSAO,
            FCT_MODELOCONTRATO.DTULTATU,
            FCT_MODELOCONTRATO.NRORGULTATU,
            FCT_MODELOCONTRATO.CDOPERULTATU,
            OPATU.NMOPERADOR AS NMOPERULTATU,
            FCT_MODELOCONTRATO.IDATIVO,
            FCT_MODELOCONTRATO.IDRENOVACAOAUTOMATICA,
            FCT_MODELOCONTRATO.IDREAJUSTEAUTOMATICO,
            FCT_MODELOCONTRATO.IDASSELETRDIGITAL,
            FCT_MODELOCONTRATO.IDBLOQALTDTINICONTRENEG,
            FCT_MODELOCONTRATO.IDENVIADOCOPERRESPCONCASS,
            FCT_MODELOCONTRATO.NRTIPODOCCERTSIGN,
            TIPODOC.NMTIPODOCCERTSIGN,
            FCT_MODELOCONTRATO.CDCENTCUST,
            CENTCUST.NMCENTCUST,
            FCT_MODELOCONTRATO.IDINTEGRACAOFM,
            FCT_MODELOCONTRATO.IDINTEGRACAOHCM,
            FCT_MODELOCONTRATO.IDINTEGRALOCAISFM,
            FCT_MODELOCONTRATO.IDINTEGRAMEDICAOFM,
            FCT_MODELOCONTRATO.IDTIPOSERVINTTECFOOD,
            FCT_MODELOCONTRATO.IDINTEGRACAOTECFOOD
        FROM
            FCT_MODELOCONTRATO
            LEFT JOIN MODPGTO ON FCT_MODELOCONTRATO.CDMODPGTO = MODPGTO.CDMODPGTO
                                AND FCT_MODELOCONTRATO.NRORG = MODPGTO.NRORG
            LEFT JOIN OPERADOR            OPINC ON FCT_MODELOCONTRATO.CDOPERINCLUSAO = OPINC.CDOPERADOR
                                        AND FCT_MODELOCONTRATO.NRORG = OPINC.NRORG
            LEFT JOIN OPERADOR            OPATU ON FCT_MODELOCONTRATO.CDOPERULTATU = OPATU.CDOPERADOR
                                        AND FCT_MODELOCONTRATO.NRORG = OPATU.NRORG
            LEFT JOIN FCT_TIPODOCCERTSIGN TIPODOC ON FCT_MODELOCONTRATO.NRTIPODOCCERTSIGN = TIPODOC.NRTIPODOCCERTSIGN
                                                    AND FCT_MODELOCONTRATO.NRORG = TIPODOC.NRORG
            LEFT JOIN CENTCUST ON FCT_MODELOCONTRATO.CDCENTCUST = CENTCUST.CDCENTCUST";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTabEscopoFaturamento($params)
    {
        $sql = "SELECT
            ESCMOD.NRESCOPOMORCONT,
            ESCMOD.NRSEQMODCONTRA,
            ESCMOD.NRTIPOORCAMENTO,
            ESCMOD.NRORG,
            ESCMOD.IDATIVO,
            ESCMOD.DTINCLUSAO,
            ESCMOD.DTULTATU,
            ESCMOD.NRORGINCLUSAO,
            ESCMOD.CDOPERINCLUSAO,
            ESCMOD.NRORGULTATU,
            ESCMOD.CDOPERULTATU,
            ESCOPO.NMTIPOORCAMENTO
        FROM
                FCT_RELACESCOPOMODCONT ESCMOD
            JOIN FCT_TIPOORCAMENTO ESCOPO ON ESCMOD.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO
            AND ESCMOD.NRORG = ESCOPO.NRORG
            WHERE NRSEQMODCONTRA = :NRSEQMODCONTRA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getTabModeloDocumento($params)
    {
        $sql = "SELECT
            FCT_MODELODOCCONTR.IDPERMITEDOCX,
            LISTAGG(FCT_MODELODOCCONTR.NRSEQMODELOCCONTR, ', ') WITHIN GROUP(
            ORDER BY
                FCT_MODELODOCCONTR.NRSEQMODELOCCONTR
            )                AS NRSEQMODELOCCONTR,
            LISTAGG(FCT_MODELODOCCONTR.IDSITUACAOCONTRATO, ',') WITHIN GROUP(
            ORDER BY
                FCT_MODELODOCCONTR.NRSEQMODELOCCONTR
            )                AS IDSITUACAOCONTRATO,
            FCT_MODELODOCCONTR.NRSEQMODCONTRA,
            FCT_MODELODOCCONTR.NRSEQMODDOCFCT,
            FCT_MODELODOC.DSMODELODOCORCA,
            FCT_MODELODOCCONTR.IDMODPADRAO,
            FCT_MODELODOCCONTR.NRORG,
            FCT_MODELODOCCONTR.DTINCLUSAO,
            FCT_MODELODOCCONTR.NRORGINCLUSAO,
            FCT_MODELODOCCONTR.CDOPERINCLUSAO,
            OPINC.NMOPERADOR AS NMOPERINCLUSAO,
            FCT_MODELODOCCONTR.DTULTATU,
            FCT_MODELODOCCONTR.NRORGULTATU,
            FCT_MODELODOCCONTR.CDOPERULTATU,
            OPATU.NMOPERADOR AS NMOPERULTATU,
            FCT_MODELODOCCONTR.IDATIVO
        FROM
                FCT_MODELODOCCONTR
            JOIN FCT_MODELODOC ON FCT_MODELODOC.NRSEQMODDOCFCT = FCT_MODELODOCCONTR.NRSEQMODDOCFCT
                                AND FCT_MODELODOC.NRORG = FCT_MODELODOCCONTR.NRORG
            JOIN OPERADOR OPINC ON OPINC.CDOPERADOR = FCT_MODELODOCCONTR.CDOPERINCLUSAO
                                AND OPINC.NRORG = FCT_MODELODOCCONTR.NRORG
            JOIN OPERADOR OPATU ON OPATU.CDOPERADOR = FCT_MODELODOCCONTR.CDOPERULTATU
                                AND OPATU.NRORG = FCT_MODELODOCCONTR.NRORG
        WHERE NRSEQMODCONTRA = :NRSEQMODCONTRA
        GROUP BY
            FCT_MODELODOCCONTR.IDPERMITEDOCX,
            FCT_MODELODOCCONTR.NRSEQMODCONTRA,
            FCT_MODELODOCCONTR.NRSEQMODDOCFCT,
            FCT_MODELODOC.DSMODELODOCORCA,
            FCT_MODELODOCCONTR.IDMODPADRAO,
            FCT_MODELODOCCONTR.NRORG,
            FCT_MODELODOCCONTR.DTINCLUSAO,
            FCT_MODELODOCCONTR.NRORGINCLUSAO,
            FCT_MODELODOCCONTR.CDOPERINCLUSAO,
            OPINC.NMOPERADOR,
            FCT_MODELODOCCONTR.DTULTATU,
            FCT_MODELODOCCONTR.NRORGULTATU,
            FCT_MODELODOCCONTR.CDOPERULTATU,
            OPATU.NMOPERADOR,
            FCT_MODELODOCCONTR.IDATIVO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getTabPerfisAcesso($params)
    {
        $sql = "SELECT
            REL.NRRELMODCONTPERFACESS,
            REL.NRSEQMODCONTRA,
            REL.NRPERFILACESSO,
            REL.NRORG,
            REL.IDATIVO,
            REL.DTINCLUSAO,
            REL.NRORGINCLUSAO,
            REL.CDOPERINCLUSAO,
            REL.DTULTATU,
            REL.NRORGULTATU,
            REL.CDOPERULTATU,
            PER.NMPERFILACESSO
        FROM
                FCT_RELMODCONTPERFACESS REL
            JOIN PERFILACESSO PER ON PER.NRPERFILACESSO = REL.NRPERFILACESSO
            WHERE NRSEQMODCONTRA = :NRSEQMODCONTRA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getTabSignatariosPadroes($params)
    {
        $sql = "SELECT
            FCT_SIGNATPADRMODCONT.NRSIGNATPADRCONT,
            FCT_SIGNATPADRMODCONT.NRSEQMODCONTRA,
            FCT_SIGNATPADRMODCONT.NRPARCNEGOCIO,
            PARCNEGOCIO.NMPRINCIPALPARC,
            PARCNEGOCIO.NRINSCRICAOPARC,
            FCT_SIGNATPADRMODCONT.IDTIPOASSINATURA,
            FCT_SIGNATPADRMODCONT.IDTESTEMUNHA,
            FCT_SIGNATPADRMODCONT.NRORDENACAO,
            FCT_SIGNATPADRMODCONT.IDATIVO,
            FCT_SIGNATPADRMODCONT.NRORG,
            FCT_SIGNATPADRMODCONT.DTINCLUSAO,
            FCT_SIGNATPADRMODCONT.NRORGINCLUSAO,
            FCT_SIGNATPADRMODCONT.CDOPERINCLUSAO,
            FCT_SIGNATPADRMODCONT.DTULTATU,
            FCT_SIGNATPADRMODCONT.NRORGULTATU,
            FCT_SIGNATPADRMODCONT.CDOPERULTATU,
            FCT_SIGNATPADRMODCONT.IDTPSIGNATARIO,
            FCT_SIGNATPADRMODCONT.DSEMAILNOTSIGNENV,
            FCT_SIGNATPADRMODCONT.DSEMAILNOTIFOUTROS,
            (
                SELECT
                    RTRIM(XMLAGG(XMLELEMENT(E, CDOPERADOR, ',').EXTRACT('//text()')
                        ORDER BY
                            NRRELOPERNOTIFASSELE
                    ).GETCLOBVAL(), ',') AS NRRELOPERNOTIFASSELE
                FROM
                    FCT_RELACOPERNOTIFASSELE
                WHERE
                        NRSIGNATPADRCONT = FCT_SIGNATPADRMODCONT.NRSIGNATPADRCONT
                    AND NRORG = FCT_SIGNATPADRMODCONT.NRORG
            ) AS CDOPERADOR
        FROM
            FCT_SIGNATPADRMODCONT
            LEFT JOIN PARCNEGOCIO ON FCT_SIGNATPADRMODCONT.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
                                    AND FCT_SIGNATPADRMODCONT.NRORG = PARCNEGOCIO.NRORG
            JOIN FCT_MODELOCONTRATO ON FCT_SIGNATPADRMODCONT.NRSEQMODCONTRA = FCT_MODELOCONTRATO.NRSEQMODCONTRA
                                    AND FCT_SIGNATPADRMODCONT.NRORG = FCT_MODELOCONTRATO.NRORG
        WHERE FCT_SIGNATPADRMODCONT.NRSEQMODCONTRA = :NRSEQMODCONTRA
        ORDER BY
            FCT_SIGNATPADRMODCONT.NRORDENACAO,
            PARCNEGOCIO.NMPRINCIPALPARC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function saveModalAddContractModel($params)
    {
        $sql = "INSERT INTO FCT_MODELOCONTRATO 
                       (NMMODCONTRATO,
                        IDATIVO,
                        CDMODCONTRATO,
                        IDGERAPROPOSTA,
                        CDCENTCUST,
                        NRDIASVIGCONT,
                        IDRENOVACAOAUTOMATICA,
                        NRDIASPRORGCONT,
                        IDBLOQALTDTINICONTRENEG,
                        IDREAJUSTEAUTOMATICO,
                        NRDIASREAJAUTOMATICO,
                        IDINTEGRACAOFM,
                        IDINTEGRALOCAISFM,
                        IDINTEGRAMEDICAOFM,
                        IDASSELETRDIGITAL,
                        NRTIPODOCCERTSIGN,
                        IDENVIADOCOPERRESPCONCASS,
                        NRORG,
                        CDOPERINCLUSAO,
                        NRSEQMODCONTRA,
                        IDINTEGRACAOTECFOOD,
                        IDTIPOSERVINTTECFOOD,
                        DTINCLUSAO)

                VALUES (:NMMODCONTRATO,
                        :IDATIVO,
                        :CDMODCONTRATO,
                        :IDGERAPROPOSTA,
                        :CDCENTCUST,
                        :NRDIASVIGCONT,
                        :IDRENOVACAOAUTOMATICA,
                        :NRDIASPRORGCONT,
                        :IDBLOQALTDTINICONTRENEG,
                        :IDREAJUSTEAUTOMATICO,
                        :NRDIASREAJAUTOMATICO,
                        :IDINTEGRACAOFM,
                        :IDINTEGRALOCAISFM,
                        :IDINTEGRAMEDICAOFM,
                        :IDASSELETRDIGITAL,
                        :NRTIPODOCCERTSIGN,
                        :IDENVIADOCOPERRESPCONCASS,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        :NRSEQMODCONTRA,
                        :IDINTEGRACAOTECFOOD,
                        :IDTIPOSERVINTTECFOOD,
                        SYSDATE)";
        $this->connection->executeStatement($sql, $params);
    }

    public function editContractModel($params)
    {
        $sql = "UPDATE FCT_MODELOCONTRATO
                   SET 
                        NMMODCONTRATO             = :NMMODCONTRATO,
                        IDATIVO                   = :IDATIVO,
                        CDMODCONTRATO             = :CDMODCONTRATO,
                        IDGERAPROPOSTA            = :IDGERAPROPOSTA,
                        CDCENTCUST                = :CDCENTCUST,
                        NRDIASVIGCONT             = :NRDIASVIGCONT,
                        IDRENOVACAOAUTOMATICA     = :IDRENOVACAOAUTOMATICA,
                        NRDIASPRORGCONT           = :NRDIASPRORGCONT,
                        IDBLOQALTDTINICONTRENEG   = :IDBLOQALTDTINICONTRENEG,
                        IDREAJUSTEAUTOMATICO      = :IDREAJUSTEAUTOMATICO,
                        NRDIASREAJAUTOMATICO      = :NRDIASREAJAUTOMATICO,
                        IDINTEGRACAOFM            = :IDINTEGRACAOFM,
                        IDINTEGRALOCAISFM         = :IDINTEGRALOCAISFM,
                        IDINTEGRACAOHCM           = :IDINTEGRACAOHCM,
                        IDINTEGRAMEDICAOFM        = :IDINTEGRAMEDICAOFM,
                        IDASSELETRDIGITAL         = :IDASSELETRDIGITAL,
                        NRTIPODOCCERTSIGN         = :NRTIPODOCCERTSIGN,
                        IDENVIADOCOPERRESPCONCASS = :IDENVIADOCOPERRESPCONCASS,
                        NRORG                     = :NRORG,
                        CDOPERULTATU              = :CDOPERULTATU,
                        IDINTEGRACAOTECFOOD       = :IDINTEGRACAOTECFOOD,
                        IDTIPOSERVINTTECFOOD      = :IDTIPOSERVINTTECFOOD,
                        DTULTATU                  = SYSDATE
                WHERE NRSEQMODCONTRA   = :NRSEQMODCONTRA";

        $this->connection->executeStatement($sql, $params);
    }

    public function deleteContractModel($parametros)
    {
        $sql = "DELETE FROM FCT_MODELOCONTRATO
                WHERE NRSEQMODCONTRA IN (".$parametros.")";
        
        $this->connection->executeStatement($sql);
    }

    public function deleteContractModelTabEscopoFaturamento($parametros)
    {
        $sql = "DELETE FROM FCT_RELACESCOPOMODCONT
                WHERE NRESCOPOMORCONT IN (".$parametros.")";
        
        $this->connection->executeStatement($sql);
    }

    public function deleteContractModelTabModeloDocumento($parametros)
    {
        $sql = "DELETE FROM FCT_MODELODOCCONTR
                WHERE NRSEQMODELOCCONTR IN (".$parametros.")";
        
        $this->connection->executeStatement($sql);
    }

    public function deleteContractModelTabPerfisAcesso($parametros)
    {
        $sql = "DELETE FROM FCT_RELMODCONTPERFACESS
                WHERE NRPERFILACESSO IN (".$parametros.")";
        
        $this->connection->executeStatement($sql);
    }

    public function deleteContractModelTabSignatariosPadroes($parametros)
    {
        $sql = "DELETE FROM FCT_RELACOPERNOTIFASSELE
                WHERE NRSIGNATPADRCONT IN (".$parametros.")";
        $this->connection->executeStatement($sql);

        $sql = "DELETE FROM FCT_SIGNATPADRMODCONT
                WHERE NRSIGNATPADRCONT IN (".$parametros.")";
        $this->connection->executeStatement($sql);
    }

    public function getEscopoDeFaturamento()
    {
        $sql = "SELECT
            ESCMOD.NRESCOPOMORCONT,
            ESCMOD.NRSEQMODCONTRA,
            ESCMOD.NRTIPOORCAMENTO,
            ESCMOD.NRORG,
            ESCMOD.IDATIVO,
            ESCMOD.DTINCLUSAO,
            ESCMOD.DTULTATU,
            ESCMOD.NRORGINCLUSAO,
            ESCMOD.CDOPERINCLUSAO,
            ESCMOD.NRORGULTATU,
            ESCMOD.CDOPERULTATU,
            ESCOPO.NMTIPOORCAMENTO
        FROM
                FCT_RELACESCOPOMODCONT ESCMOD
            JOIN FCT_TIPOORCAMENTO ESCOPO ON ESCMOD.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO
            AND ESCMOD.NRORG = ESCOPO.NRORG";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function saveModalAddContractModelTabEscopoFaturamento($params)
    {
        $sql = "INSERT INTO FCT_RELACESCOPOMODCONT 
                        (NRSEQMODCONTRA,
                        NRTIPOORCAMENTO,
                        NRESCOPOMORCONT,
                        IDATIVO,
                        NRORG,
                        CDOPERINCLUSAO,
                        DTINCLUSAO)

                VALUES (:NRSEQMODCONTRA,    
                        :NRTIPOORCAMENTO,
                        :NRESCOPOMORCONT,
                        :IDATIVO,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        SYSDATE)";
        $this->connection->executeStatement($sql, $params);
    }

    public function saveModalAddContractModelTabModeloDocumento($params)
    {
        $sql = "INSERT INTO FCT_MODELODOCCONTR 
                       (NRSEQMODELOCCONTR,
                        NRSEQMODCONTRA,
                        NRSEQMODDOCFCT,
                        IDSITUACAOCONTRATO,
                        IDPERMITEDOCX,
                        IDATIVO,
                        NRORG,
                        CDOPERINCLUSAO,
                        CDOPERULTATU,
                        DTINCLUSAO)

                VALUES (:NRSEQMODELOCCONTR,
                        :NRSEQMODCONTRA,
                        :NRSEQMODDOCFCT,
                        :IDSITUACAOCONTRATO,
                        :IDPERMITEDOCX,
                        :IDATIVO,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        :CDOPERULTATU,
                        SYSDATE)";
        $this->connection->executeStatement($sql, $params);
    }

    public function saveModalAddContractModelTabPerfisAcesso($params)
    {
        $sql = "INSERT INTO FCT_RELMODCONTPERFACESS 
                       (NRSEQMODCONTRA,
                        IDATIVO,
                        NRPERFILACESSO,
                        NRORG,
                        CDOPERINCLUSAO,
                        NRRELMODCONTPERFACESS,
                        DTINCLUSAO)

                VALUES (:NRSEQMODCONTRA,
                        :IDATIVO,
                        :NRPERFILACESSO,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        :NRRELMODCONTPERFACESS,
                        SYSDATE)";
        $this->connection->executeStatement($sql, $params);
    }

    public function saveModalAddContractModelTabSignatariosPadroes($params)
    {
        $sql = "INSERT INTO FCT_SIGNATPADRMODCONT 
                       (NRSIGNATPADRCONT,
                        NRSEQMODCONTRA,
                        IDTPSIGNATARIO,
                        NRPARCNEGOCIO,
                        IDTIPOASSINATURA,
                        IDTESTEMUNHA,
                        NRORDENACAO,
                        DSEMAILNOTSIGNENV,
                        DSEMAILNOTIFOUTROS,
                        NRORG,
                        CDOPERINCLUSAO,
                        IDATIVO,
                        DTINCLUSAO)

                VALUES (:NRSIGNATPADRCONT,
                        :NRSEQMODCONTRA,
                        :IDTPSIGNATARIO,
                        :NRPARCNEGOCIO,
                        :IDTIPOASSINATURA,
                        :IDTESTEMUNHA,
                        :NRORDENACAO,
                        :DSEMAILNOTSIGNENV,
                        :DSEMAILNOTIFOUTROS,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        :IDATIVO,
                        SYSDATE)";
        $this->connection->executeStatement($sql, $params);
        // var_dump($params);
        // die;
    }

    public function saveOperadoresSigPadrao($params)
    {
        $sql = "INSERT INTO FCT_RELACOPERNOTIFASSELE 
                       (NRRELOPERNOTIFASSELE,
                        NRSIGNATPADRCONT,
                        CDOPERADOR,
                        NRORG,
                        CDOPERINCLUSAO,
                        IDATIVO,
                        DTINCLUSAO)

                VALUES (:NRRELOPERNOTIFASSELE,
                        :NRSIGNATPADRCONT,
                        :CDOPERADOR,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        :IDATIVO,
                        SYSDATE)";
        $this->connection->executeStatement($sql, $params);
        // var_dump('saveOperadoresSigPadrao');
        // die;
    }

    public function getModeloDeDocumento()
    {
        $sql = "SELECT
            NRSEQMODDOCFCT,
            DSMODELODOCORCA
        FROM FCT_MODELODOC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getPerfisDeAcesso()
    {
        $sql = "SELECT
            NRPERFILACESSO,
            NMPERFILACESSO
        FROM PERFILACESSO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getSignatariosContractModel()
    {
        $sql = "SELECT
                    PARCNEGOCIO.NRPARCNEGOCIO,
                    PARCNEGOCIO.NMPRINCIPALPARC,
                    PARCNEGOCIO.NRINSCRICAOPARC,
                    PARCNEGOCIO.NMSECUNDARIPARC,
                    OPERADOR.CDOPERADOR,
                    PARCNEGOCIO.NRORG
                FROM
                        PARCNEGOCIO
                JOIN PARCERIA ON PARCNEGOCIO.NRPARCNEGOCIO = PARCERIA.NRPARCNEGOCIO
                    AND PARCNEGOCIO.NRORG = PARCERIA.NRORG
                    AND PARCNEGOCIO.IDATIVO = PARCERIA.IDATIVO
                    AND PARCERIA.CDTIPOPARCEIRO = 'OPERADOR'
                    AND PARCERIA.IDATIVO = 'S'
                JOIN OPERADOR ON PARCNEGOCIO.NRPARCNEGOCIO = OPERADOR.NRPARCNEGOCIO
                    AND PARCNEGOCIO.NRORG = OPERADOR.NRORG
                    AND OPERADOR.IDOPERATIVO = 'A'
                WHERE PARCNEGOCIO.CDTIPOINSCRICAO = 'CPF'
                    AND PARCNEGOCIO.IDATIVO = 'S'
                ORDER BY PARCNEGOCIO.NMPRINCIPALPARC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getOperadoresContractModel()
    {
        $sql = "SELECT
                    CDOPERADOR,
                    NMOPERADOR
                FROM OPERADOR
                ORDER BY NMOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getCpfSignatario($params)
    {
        $sql = "SELECT
                    NRINSCRICAOPARC
                FROM PARCNEGOCIO
                WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }
}
