<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class MapaFaturamentoFactory
{
    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getMapaFaturamento($parametros)
    {
        $sql = "SELECT * 
        FROM (SELECT MES1.CDSERVORCA, MES1.NMSERVORCA, NULL AS NRSEQCONTRATO, NULL AS CONTRATO, NULL AS NRPARCNEGOCIO, NULL AS NMPARCEIRO, 'S_'||MES1.CDSERVORCA AS DSARVORE, NULL AS DSARVORESUP,
                NVL(MES1.COMPETENCIA1, 0) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                NVL(MES2.COMPETENCIA2, 0) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                NVL(MES3.COMPETENCIA3, 0) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3
         FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO1, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA1,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO1 
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES1
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO2, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA2,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO2 
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES2
          ON MES2.CDSERVORCA = MES1.CDSERVORCA
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO3, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA3,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO3
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES3
          ON MES3.CDSERVORCA = MES1.CDSERVORCA
          
          UNION ALL
          
          SELECT MES1.CDSERVORCA, MES1.NMSERVORCA, NULL AS NRSEQCONTRATO, NULL AS CONTRATO, MES1.NRPARCFATURA AS NRPARCNEGOCIO, MES1.NMPARCEIRO, 'S_'||MES1.CDSERVORCA||'_P_'||MES1.NRPARCFATURA AS DSARVORE, 'S_'||MES1.CDSERVORCA AS DSARVORESUP,
                 NVL(MES1.COMPETENCIA1, 0) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                NVL(MES2.COMPETENCIA2, 0) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                NVL(MES3.COMPETENCIA3, 0) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3
           FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO1, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA1,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO1 
               FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES1
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO2, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA2,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO2 
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )',  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES2
          ON MES2.CDSERVORCA = MES1.CDSERVORCA
          AND MES2.NRPARCFATURA = MES1.NRPARCFATURA
          LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO3, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA3,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO3
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES3
          ON MES3.CDSERVORCA = MES1.CDSERVORCA
          AND MES3.NRPARCFATURA = MES1.NRPARCFATURA
          
          UNION ALL
          
          SELECT MES1.CDSERVORCA, MES1.NMSERVORCA, MES1.NRSEQCONTRATO, MES1.CONTRATO, MES1.NRPARCFATURA AS NRPARCNEGOCIO, MES1.NMPARCEIRO, 'S_'||MES1.CDSERVORCA||'_P_'||MES1.NRPARCFATURA||'_C_'||MES1.NRSEQCONTRATO AS DSARVORE, 'S_'||MES1.CDSERVORCA||'_P_'||MES1.NRPARCFATURA AS DSARVORESUP,
                NVL(MES1.COMPETENCIA1, 0) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                NVL(MES2.COMPETENCIA2, 0) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                NVL(MES3.COMPETENCIA3, 0) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3
           FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO1, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA1,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO1 
               FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
           JOIN FCT_CONTRATO CONT
             ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES1
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO2, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA2,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO2 
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
           JOIN FCT_CONTRATO CONT
             ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES2
          ON MES2.CDSERVORCA = MES1.CDSERVORCA
          AND MES2.NRPARCFATURA = MES1.NRPARCFATURA
          AND MES2.NRSEQCONTRATO = MES1.NRSEQCONTRATO
          LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO3, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA3,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO3
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
            JOIN FCT_CONTRATO CONT
             ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES3
          ON MES3.CDSERVORCA = MES1.CDSERVORCA
          AND MES3.NRPARCFATURA = MES1.NRPARCFATURA
          AND MES3.NRSEQCONTRATO = MES1.NRSEQCONTRATO)
          $parametros";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getMapaFaturamento2($parametros)
    {
        $sql = "SELECT DISTINCT *  
        FROM (SELECT MES1.CDSERVORCA, MES1.NMSERVORCA, NULL AS NRSEQCONTRATO, NULL AS CONTRATO, NULL AS NRPARCNEGOCIO, NULL AS NMPARCEIRO, 'S_'||MES1.CDSERVORCA AS DSARVORE, NULL AS DSARVORESUP,
                NVL(MES1.COMPETENCIA1, 0) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                NVL(MES2.COMPETENCIA2, 0) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                NVL(MES3.COMPETENCIA3, 0) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3
         FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO1, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA1,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO1 
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES1
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO2, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA2,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO2 
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES2
          ON MES2.CDSERVORCA = MES1.CDSERVORCA
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO3, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA3,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO3
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES3
          ON MES3.CDSERVORCA = MES1.CDSERVORCA
          
          UNION ALL
          
          SELECT MES1.CDSERVORCA, MES1.NMSERVORCA, NULL AS NRSEQCONTRATO, NULL AS CONTRATO, MES1.NRPARCFATURA AS NRPARCNEGOCIO, MES1.NMPARCEIRO, 'S_'||MES1.CDSERVORCA||'_P_'||MES1.NRPARCFATURA AS DSARVORE, 'S_'||MES1.CDSERVORCA AS DSARVORESUP,
                 NVL(MES1.COMPETENCIA1, 0) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                NVL(MES2.COMPETENCIA2, 0) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                NVL(MES3.COMPETENCIA3, 0) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3
           FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO1, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA1,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO1 
               FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES1
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO2, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA2,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO2 
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )',  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES2
          ON MES2.CDSERVORCA = MES1.CDSERVORCA
          AND MES2.NRPARCFATURA = MES1.NRPARCFATURA
          LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO3, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA3,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO3
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES3
          ON MES3.CDSERVORCA = MES1.CDSERVORCA
          AND MES3.NRPARCFATURA = MES1.NRPARCFATURA
          
          UNION ALL
          
          SELECT MES1.CDSERVORCA, MES1.NMSERVORCA, MES1.NRSEQCONTRATO, MES1.CONTRATO, MES1.NRPARCFATURA AS NRPARCNEGOCIO, MES1.NMPARCEIRO, 'S_'||MES1.CDSERVORCA||'_P_'||MES1.NRPARCFATURA||'_C_'||MES1.NRSEQCONTRATO AS DSARVORE, 'S_'||MES1.CDSERVORCA||'_P_'||MES1.NRPARCFATURA AS DSARVORESUP,
                NVL(MES1.COMPETENCIA1, 0) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                NVL(MES2.COMPETENCIA2, 0) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                NVL(MES3.COMPETENCIA3, 0) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3
           FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO1, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA1,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO1 
               FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
           JOIN FCT_CONTRATO CONT
             ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES1
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO2, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA2,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO2 
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
           JOIN FCT_CONTRATO CONT
             ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES2
          ON MES2.CDSERVORCA = MES1.CDSERVORCA
          AND MES2.NRPARCFATURA = MES1.NRPARCFATURA
          AND MES2.NRSEQCONTRATO = MES1.NRSEQCONTRATO
          LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                ROUND(SUM(ITCONT.VRTOTITEMCONT),2) AS ESTIMADO3, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, ROUND((SUM(ITEM.VRFATURADO) - SUM(ITCONT.VRTOTITEMCONT)),2) AS DIFERENCA3,
                ROUND(((SUM(ITEM.VRFATURADO) *100)/ DECODE(SUM(ITCONT.VRTOTITEMCONT),0,1,SUM(ITCONT.VRTOTITEMCONT))),2) AS DESVIO3
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
            JOIN FCT_CONTRATO CONT
             ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES3
          ON MES3.CDSERVORCA = MES1.CDSERVORCA
          AND MES3.NRPARCFATURA = MES1.NRPARCFATURA
          AND MES3.NRSEQCONTRATO = MES1.NRSEQCONTRATO)
          $parametros";

        $data = $this->connection->fetchAll($sql);
        return  $this->buildResponseData($data);
    }
}
