/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_NUTR                                                     */
/* Tabela : NUTRIENTE                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 05/07/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_NUTR
BEFORE INSERT OR UPDATE OR DELETE
ON NUTRIENTE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUNUTR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDNUTRIENTE,0) <> NVL(:NEW.CDNUTRIENTE,0)) OR
         (NVL(:OLD.NMNUTRIENTE,0) <> NVL(:NEW.NMNUTRIENTE,0)) OR
         (NVL(:OLD.SGUNIDADE  ,0)   <> NVL(:NEW.SGUNIDADE  ,0)) OR
         (NVL(:OLD.NMREDUZIDO ,0)  <> NVL(:NEW.NMREDUZIDO ,0)) THEN
         :NEW.DTULTATUNUTR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('NUTRIENTE', '', 'CDNUTRIENTE='||:OLD.CDNUTRIENTE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE NUTRIENTE MODIFY DTULTATUNUTR DEFAULT SYSDATE
/
