/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CONCORRENTE                                              */
/* Tabela : CONCORRENTE                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 17/08/2004 - Welbert G. Moitinha                                           */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CONCORRENTE
BEFORE INSERT OR UPDATE OR DELETE
ON CONCORRENTE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCONC := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (:OLD.CDCONCORRENT <> :NEW.CDCONCORRENT) OR
         (:OLD.NMCONCORRENT <> :NEW.NMCONCORRENT) THEN
         :NEW.DTULTATUCONC := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CONCORRENTE', '', 'CDCONCORRENT='||:OLD.CDCONCORRENT||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CONCORRENTE MODIFY DTULTATUCONC DEFAULT SYSDATE
/
