/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCOBR                                                 */
/* Tabela : TIPOCOBR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOCOBR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOCOBR
GO

CREATE TRIGGER DTULTATU_TIPOCOBR
ON TIPOCOBR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOCOBR', null, 'CDTIPCOB='+ CDTIPCOB+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOCOBR
      SET DTULTATUTPCB = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOCOBR.CDTIPCOB,0)   = ISNULL(INSERTED.CDTIPCOB,0))   AND
            (ISNULL(TIPOCOBR.NMTIPOCOBR,0) = ISNULL(INSERTED.NMTIPOCOBR,0));
   END;
END;
GO

