import { IEventParam, Metadata } from '@zeedhi/core';
import { Button } from '@zeedhi/common';
import {
    TekRestDatasource, TekTreeGrid,
} from '@zeedhi/teknisa-components-common';

export class MapaFaturamentoController {
    public currentRow : any = {};

    public openFilter({ component }: any) {
        const filterButton = Metadata.getInstance<Button>(`${component.name}_filterButton`);
        filterButton.click({} as Event, {} as HTMLElement);
    }

    public colorDiferenca1({ row }: any) {
        let color;

        if (row.DIFERENCA1 === 0) {
            color = { color: '#000000' };
        } else if (row.DIFERENCA1 < 0) {
            color = { color: '#FF0000' };
        } else if (row.DIFERENCA1 > 0) {
            color = { color: '#008000' };
        }

        return color;
    }

    public colorDiferenca2({ row }: any) {
        let color;

        if (row.DIFERENCA2 === 0) {
            color = { color: '#000000' };
        } else if (row.DIFERENCA2 < 0) {
            color = { color: '#FF0000' };
        } else if (row.DIFERENCA2 > 0) {
            color = { color: '#008000' };
        }

        return color;
    }

    public colorDiferenca3({ row }: any) {
        let color;

        if (row.DIFERENCA3 === 0) {
            color = { color: '#000000' };
        } else if (row.DIFERENCA3 < 0) {
            color = { color: '#FF0000' };
        } else if (row.DIFERENCA3 > 0) {
            color = { color: '#008000' };
        }

        return color;
    }

    public colorDesv1({ row }: any) {
        let color;

        if (row.DESVIO1 === 100) {
            color = { color: '#000000' };
        } else if (row.DESVIO1 < 80) {
            color = { color: '#FF0000' };
        } else if (row.DESVIO1 > 200) {
            color = { color: '#FF7F00' };
        }

        return color;
    }

    public colorDesv2({ row }: any) {
        let color;

        if (row.DESVIO2 === 100) {
            color = { color: '#000000' };
        } else if (row.DESVIO2 < 80) {
            color = { color: '#FF0000' };
        } else if (row.DESVIO2 > 200) {
            color = { color: '#FF7F00' };
        }

        return color;
    }

    public colorDesv3({ row }: any) {
        let color;

        if (row.DESVIO3 === 100) {
            color = { color: '#000000' };
        } else if (row.DESVIO3 < 80) {
            color = { color: '#FF0000' };
        } else if (row.DESVIO3 > 200) {
            color = { color: '#FF7F00' };
        }

        return color;
    }

    public colunaCinza() {
        return 'coluna-cinza';
    }

    public filtrarCliente({ component }: any) {
        component.datasource.setFilter({
            tipoParc: ['CLIENTE'],
        });
    }

    public filterParent({ component }: IEventParam<TekTreeGrid>) {
        delete component.datasource.filter[component.parentField];

        if (!(component.datasource instanceof TekRestDatasource)) {
            return;
        }
        if (Object.keys(component.datasource.dynamicFilter).length === 0) {
            component.fetchOnDemand = true;
            component.treeDataStructure.fetchOnDemand = true;
        } else {
            component.fetchOnDemand = false;
            component.treeDataStructure.fetchOnDemand = false;
        }
    }
}
